/***************************************************************************
 *  Original Diku Mud copyright (C) 1990, 1991 by Sebastian Hammer,        *
 *  Michael Seifert, Hans Henrik St{rfeldt, Tom Madsen, and Katja Nyboe.   *
 *                                                                         *
 *  Merc Diku Mud improvments copyright (C) 1992, 1993 by Michael          *
 *  Chastain, Michael Quan, and Mitchell Tse.                              *
 *                                                                         *
 *  In order to use any part of this Merc Diku Mud, you must comply with   *
 *  both the original Diku license in 'license.doc' as well the Merc       *
 *  license in 'license.txt'.  In particular, you may not remove either of *
 *  these copyright notices.                                               *
 *                                                                         *
 *  Much time and thought has gone into this software and you are          *
 *  benefitting.  We hope that you share your changes too.  What goes      *
 *  around, comes around.                                                  *
 ***************************************************************************/

/* Special Bits */

#define SPC_CHAMPION	A /* PLR_CHAMPION 4 */
#define SPC_DEMON_LORD	B /* OLD_DEMON Flag */
#define SPC_WOLFMAN	C /* old PLR_WOLFMAN */
#define SPC_PRINCE      D /* old EXTRA_PRINCE */
#define SPC_SIRE	E /* Old EXTRA_SIRE */
#define SPC_ANARCH      F /* old extra_anarch */
#define SPC_INCONNU     G /* old extra_inconnu */
#define SPC_ANTITRIBU	H /* new antitribu bit */
#define SPC_SABBAT      I /* Sabbat sect flag */
#define SPC_CAMARILLA   J /* Camarilla sect flag */
#define SPC_INDEPENDENT K /* Indepentent sect flag */
#define SPC_INDUCTED    L /* flag for acceptance into a sect */
#define SPC_PRIMOGEN    M /* flag for a vampire primogen */
#define SPC_JUSTICAR    N /* flag for a vampire justicar */
#define SPC_PACK	O /* flag for werewolf sect The Pack */
#define SPC_BLOODHUNT   P /* flag for Camarilla bloodhunt */
#define SPC_WYRM	Q /* flag for werewolf sect The Wyrm */
#define SPC_FOLLOWERS	R /* flag for vampire sect Followers */
#define SPC_BETA	S /* flag for werewolf beta */
#define SPC_TECHNOCRACY T /* flag for mage sect */
#define SPC_NEWPACK     U /* flag for werewolf sect */
#define SPC_TRADITIONS  V /* flag for mage sect */     
#define SPC_SOCIETY_LEO W /* flag for Society of Leopold*/
#define SPC_ELDER		X
#define SPC_CARDINAL	Y	/*!< Cardnal bits for sabbat */

/* Class Bits */
#define CLASS_UNCLASS	     0	 /*lack of class*/
#define CLASS_DEMON	 		 (A)	 /* PLR_DEMON 2 */
#define CLASS_MAGE	 		 (B) 
#define CLASS_WEREWOLF		 (C) /* PLR_WEREWOLF */
#define CLASS_VAMPIRE	     (D) 
#define CLASS_HIGHLANDER     (E) /* EXTRA_HIGHLANDER */
#define CLASS_WRAITH         (F)
#define CLASS_SWWF           (G)  /* Spiral's Werewolf */
#define CLASS_TESTVAMP       (H)
#define CLASS_HUNTER		 (I)

/* 
 * Bits For Highlanders
 */
#define HPOWER_WPNSKILL 0

/* 
 * Bits For Mages
 */
#define MPOWER_RUNE0	0
#define MPOWER_RUNE1	1
#define MPOWER_RUNE2	2
#define MPOWER_RUNE3	3
#define MPOWER_RUNE4	4

/*
 * Bits for Werewolves 
 */
/* Stats */

#define UNI_GEN        	0 /* vampgen */
#define UNI_AFF		1 /* vampaff */
#define UNI_CURRENT	2 /* vamppass */
#define UNI_RAGE	3 /* ch->wolf = how big rage they are in*/
#define UNI_FORM0      	4/* wolfform[0] */
#define UNI_FORM1      	5 /* wolfform[1] */
#define	WOLF_POLYAFF	6
#define UNI_BLOOD_MAX   7
#define UNI_BLOOD_POT   8

/* 
 * Powers 
 * Totems for werewolves.
 */

#define WPOWER_MANTIS	      0
#define WPOWER_BEAR	      1
#define WPOWER_LYNX	      2
#define WPOWER_BOAR	      3
#define WPOWER_OWL	      4
#define WPOWER_SPIDER	      5
#define WPOWER_WOLF	      6
#define WPOWER_HAWK	      7
#define WPOWER_SHARK          8
#define WPOWER_SPHINX         9
#define WPOWER_SILVER	     10
#define WPOWER_RAT           11
#define WPOWER_CHAMELEON     12

/*define Bits for Mages - Spiral in da HOUSE! */
#define SPHERE_CORRESPONDENCE  0
#define SPHERE_ENTROPY         1
#define SPHERE_FORCES          2
#define SPHERE_MIND            3
#define SPHERE_MATTER          4
#define SPHERE_PRIME           5
#define SPHERE_SPIRIT          6
#define SPHERE_LIFE            7
#define SPHERE_TIME            8


#define HEAD_NORMAL		      0
#define HEAD_WOLF		      1
#define HEAD_EAGLE		      2
#define HEAD_LION		      4
#define HEAD_SNAKE		      8

#define TAIL_NONE		      0
#define TAIL_POISONOUS		      1
#define TAIL_SCORPION		      2

#define SHAPE_HOMID		0
#define SHAPE_GLABRO		1
#define SHAPE_CRINOS		2
#define SHAPE_HISPO		3
#define SHAPE_LUPUS		4

#define RENOWN_HONOR            0
#define RENOWN_GLORY            1
#define RENOWN_WISDOM           2
#define TRENOWN_HONOR            0
#define TRENOWN_GLORY            1
#define TRENOWN_WISDOM           2

#define RAGE_MAX              200

#define FRENZY_FIGHT			1
#define FRENZY_FLIGHT			2

/*
 * defined tribes for those hairy Beasts
 */
#define BREED_HOMID		      	  0
#define BREED_LUPUS		      	  1
#define BREED_METIS		      	  2
#define BREED_MAX		      	  2

#define AUSPICE_RAGABASH	      0
#define AUSPICE_THEURGE		      1
#define AUSPICE_PHILODOX	      2
#define AUSPICE_GALLIARD	      3
#define AUSPICE_AHROUN		      4
#define AUSPICE_MAX		      	  4

#define TRIBE_BLACK_FURIES	      0
#define TRIBE_BONE_GNAWERS	      1
#define TRIBE_CHILDREN_OF_GAIA	  2
#define TRIBE_FIANNA		      3
#define TRIBE_GET_OF_FENRIS	      4
#define TRIBE_GLASS_WALKERS	      5
#define TRIBE_RED_TALONS	      6
#define TRIBE_SHADOW_LORDS	      7
#define TRIBE_SILENT_STRIDERS	  8
#define TRIBE_SILVER_FANGS	      9
#define TRIBE_STARGAZERS	      10
#define TRIBE_UKTENA		      11
#define TRIBE_WENDIGO		      12
#define TRIBE_RONIN               13
#define TRIBE_CHILD_OF_SPIRAL     14
#define TRIBE_BSD                 15
#define TRIBE_BASTET			  16
#define TRIBE_GLASSWALKERS        17
#define TRIBE_MAX		          17

#define GT_NONE					 0
#define GT_BREED				 1
#define GT_AUSPICE				 2
#define GT_TRIBE				 3

/*Defines for Integer Clans.. so I can add and change online.. */

/*vampires first */
#define CLAN_NONE					0
#define CLAN_BAALI					1
#define CLAN_BLOOD_BROTHERS     	2
#define CLAN_BRUJAH					3
#define CLAN_CAPPADOCIANS			4
#define CLAN_HARBINGERS_OF_SKULLS	5
#define	CLAN_DAUGHTERS_OF_CACOPHONY	6
#define CLAN_GANGREL				7
#define	CLAN_GARGOYLES				8
#define CLAN_GIOVANNI				9
#define CLAN_KINDRED_OF_THE_EAST   10
#define CLAN_LASOMBRA			   11
#define CLAN_LAMIA				   12
#define CLAN_LHIANNAN			   13
#define CLAN_LIABON				   14
#define CLAN_MALKAVIAN			   15
#define CLAN_NAGARAJA			   16
#define CLAN_NOSFERATU			   17
#define CLAN_NICTUKU			   18
#define CLAN_RAVNOS				   19
#define CLAN_SALUBRI			   20
#define CLAN_SAMEDI				   21
#define CLAN_SETITES			   22
#define CLAN_TOREADOR			   23
#define CLAN_TREMERE			   24
#define CLAN_TRUE_BRUJAH		   25
#define CLAN_TZIMISCE			   26
#define CLAN_VENTRUE			   27
#define	CLAN_CATIFF				   28 //Loners!!!
/*Werewolf Tribes Packs*/
#define CLAN_BASTET				   29
#define CLAN_BLACK_FURIES		   30
#define CLAN_BLACK_SPIRAL_DANCERS  31
#define CLAN_BONE_GNAWERS		   32
#define CLAN_CHILDREN_OF_SPIRAL    33
#define CLAN_FIANNA				   34
#define CLAN_GET_OF_FENRIS		   35
#define	CLAN_GLASSWALKERS  		   36 //Darkage Mechanics?
#define CLAN_RED_TALONS			   37
#define CLAN_SHADOW_LORDS		   38
#define CLAN_SILENT_STRIDERS	   39
#define CLAN_SILVER_FANGS		   40
#define CLAN_STARGAZERS			   41
#define CLAN_UKETENA			   42
#define CLAN_WENDIGO			   43
/*mage traditions*/
#define CLAN_AKASHIC_BROTHERHOOD   44
#define CLAN_CELESTRIAL_CHORUS	   45
#define CLAN_CULT_OF_ECSTASY       46
#define CLAN_DREAMSPEAKERS		   47
#define CLAN_EUTHANATOS			   48
#define CLAN_HOLLOW_ONES		   49
#define CLAN_ORDER_OF_HERMES	   50
#define CLAN_SONS_OF_ETHER	       51
#define CLAN_VERBENA			   52
#define CLAN_ITERATION_X		   53
#define CLAN_PROGENITORS	       54
#define CLAN_SYNDICATE			   55
#define CLAN_NEW_WORLD_ORDER	   56
#define CLAN_VOID_ENGINEERS        57
#define CLAN_RONIN				   58
#define CLAN_ASHAMED			   59
#define CLAN_ASSAMITES			   60
#define CLAN_GAKI                  61
#define CLAN_BUSHI                 62
#define CLAN_LEOPOLD               63
#define MAX_ICLAN				   64


/*
 * True Faith Definition Here.
 */
#define TRUE_FAITH              (A)
                               
                               
/*
 * Define the max amount of Character points here.
 */
#define MAX_CPOINTS			20

/*
 * Merit/Flaw Defines
 */

#define MERIT_LUCKY				(A)
#define MERIT_WISE				(B)
#define MERIT_TOUGH				(C)
#define MERIT_WILLFULL			(D)
#define MERIT_STUDIOUS			(E)
#define MERIT_AGILE				(F)
#define MERIT_PERCEPTIVE		(G)

#define IMM_MERIT_SLASH	    	(A)	/* Resistance to slash, slice. 		*/
#define IMM_MERIT_STAB	    	(B)	/* Resistance to stab, pierce. 		*/
#define IMM_MERIT_SMASH	    	(C)	/* Resistance to blast, pound, crush. 	*/
#define IMM_MERIT_ANIMAL		(D)	/* Resistance to bite, claw. 		*/
#define IMM_MERIT_MISC	    	(E)	/* Resistance to grep, suck, whip. 	*/
#define IMM_MERIT_CHARM	    	(F)	/* Immune to charm spell. 		*/
#define IMM_MERIT_HEAT	    	(G)	/* Immune to fire/heat spells. 		*/
#define IMM_MERIT_COLD	    	(H)	/* Immune to frost/cold spells.		*/
#define IMM_MERIT_LIGHTNING		(I)	/* Immune to lightning spells.		*/
#define IMM_MERIT_ACID	    	(J)	/* Immune to acid spells.		*/
#define IMM_MERIT_SUMMON		(K)	/* Immune to being summoned.		*/
#define IMM_MERIT_VOODOO		(L)	/* Immune to voodoo magic.		*/
#define IMM_MERIT_HURL	    	(Q) /* Cannot be hurled.			*/
#define IMM_MERIT_BACKSTAB		(R) /* Cannot be backstabbed.		*/
#define IMM_MERIT_KICK	    	(S) /* Cannot be kicked.			*/
#define IMM_MERIT_DISARM		(T) /* Cannot be disarmed.			*/
#define IMM_MERIT_STEAL	    	(U) /* Cannot have stuff stolen.		*/
#define IMM_MERIT_SLEEP	    	(V) /* Immune to sleep spell.		*/
#define IMM_MERIT_DRAIN	    	(W) /* Immune to energy drain.		*/

#define IMM_FLAW_SLASH	    	(A)	/* Resistance to slash, slice. 		*/
#define IMM_FLAW_STAB	    	(B)	/* Resistance to stab, pierce. 		*/
#define IMM_FLAW_SMASH	    	(C)	/* Resistance to blast, pound, crush. 	*/
#define IMM_FLAW_ANIMAL			(D)	/* Resistance to bite, claw. 		*/
#define IMM_FLAW_MISC	    	(E)	/* Resistance to grep, suck, whip. 	*/
#define IMM_FLAW_CHARM	    	(F)	/* Immune to charm spell. 		*/
#define IMM_FLAW_HEAT	    	(G)	/* Immune to fire/heat spells. 		*/
#define IMM_FLAW_COLD	    	(H)	/* Immune to frost/cold spells.		*/
#define IMM_FLAW_LIGHTNING		(I)	/* Immune to lightning spells.		*/
#define IMM_FLAW_ACID	    	(J)	/* Immune to acid spells.		*/
#define IMM_FLAW_VOODOO			(L)	/* Immune to voodoo magic.		*/
#define IMM_FLAW_HURL	    	(Q) /* Cannot be hurled.			*/
#define IMM_FLAW_BACKSTAB		(R) /* Cannot be backstabbed.		*/
#define IMM_FLAW_KICK	    	(S) /* Cannot be kicked.			*/
#define IMM_FLAW_DISARM			(T) /* Cannot be disarmed.			*/
#define IMM_FLAW_STEAL	    	(U) /* Cannot have stuff stolen.		*/
#define IMM_FLAW_SLEEP	    	(V) /* Immune to sleep spell.		*/
#define IMM_FLAW_DRAIN	    	(W) /* Immune to energy drain.		*/

#define FLAW_UNLUCKY			(A)
#define FLAW_FOOLISH			(B)
#define FLAW_FRAGILE			(C)
#define FLAW_WEAKWILLED			(D)
#define FLAW_DUMB				(E)
#define FLAW_CLUMSY				(F)
#define	FLAW_UNPERCEPTIVE		(G)
/*
 * Mertis Type Defines
 */

#define MERIT				1
#define FLAW				2
#define IM_MERIT			3
#define IM_FLAW				4

#define REG_MERIT			0
#define REG_FLAW			0
#define IMM_MERIT			1
#define IMM_FLAW			1

/*
 * Spent Defines to track player spending
 */
#define SPENT_QP			0
#define SPENT_CP			1
#define SPENT_P				2
#define SPENT_RP			3
#define SPENT_T				4

/*
 * Define Power Types for Consolidation of Power related commands.
 */
#define PTYPE_AFFECT_SELF            1   //Affects that affect self..(No victim)
#define PTYPE_AFFECT_VICTIM          2   //Affect that Affect victims..
#define PTYPE_OFFENCE_VICTIM_ROOM    3   //Power Affects person in room fighting
#define PTYPE_OFFENCE_VICTIM_GLOBAL  4   //Player is fighting and Needs to run against the whole room
#define PTYPE_VICTIM_ROOM            5   //Standing (Non Fighting) Power that needs a victim..
#define PTYPE_VICTIM_GLOBAL          6   //Standing (Non Fighting) Power that needs a victim..
#define PTYPE_GENERAL                7   //General Power type that just needs argument
#define PTYPE_OFFENCE_ROOM           8   //General Power to room
#define PTYPE_OFFENCE_RORP           9   //General Power to Room ro victim depending on argument
#define PTYPE_VICTIM_SELF           10   //Target Can be Victim or self...

 
/* 
 * Decapitation Bits and decalres
 */ 
               
#define DECAPT_TEAR          1
#define DECAPT_DECAP         2
#define DECAPT_DIAB          3

#define DECAPO_NO_STAT       1
#define DECAPO_FOR_STAT       2
#define DECAPO_FOR_ARTI       3
#define DECAPO_RP             4

#define CLS_VAMP	0
#define CLS_BREED   1
#define CLS_AUSPICE 2
#define CLS_TRIBE	3
#define CLS_MAGE	4

#define GHOST_SANCTUARY		A
#define GHOST_ICESHIELD		B
#define GHOST_FIRESHIELD	C
#define GHOST_SHOCKSHIELD	D
#define GHOST_ACIDSHIELD	E
#define GHOST_PROTECT		F
#define GHOST_FLYING		G
#define GHOST_INVISIBLE		H
#define GHOST_SNEAK		I

#define ARCONOI_ARGOS		0 //This is Travel related Powers
#define ARCONOI_CASTIGATE	1 //Battle Related Powers
#define ARCONOI_EMBODY		2 //Do stuff in the Normal Plane powers
#define ARCONOI_KEENING		3 //Powers that influence players/mortals
#define ARCONOI_MOLIATE		4 //Power to change form and shape while in the normal plane
#define ARCONOI_OUTRAGE		5 //Powers that deal with moving items and people across plans
#define ARCONOI_USURY		6 //Power that deal with sensing the players hp,mana etc
#define ARCONOI_BEHEST 		7 //Powers that deal with other wraiths
#define ARCONOI_BEFUDDLE	8 //Powers that decive
#define ARCONOI_ERGOSIS	  	9 //Powers that deal with peoples mind	

