/***************************************************************************
 *  Original Diku Mud copyright (C) 1990, 1991 by Sebastian Hammer,	   *
 *  Michael Seifert, Hans Henrik St{rfeldt, Tom Madsen, and Katja Nyboe.   *
 *									   *
 *  Merc Diku Mud improvments copyright (C) 1992, 1993 by Michael	   *
 *  Chastain, Michael Quan, and Mitchell Tse.				   *
 *									   *
 *  In order to use any part of this Merc Diku Mud, you must comply with   *
 *  both the original Diku license in 'license.doc' as well the Merc	   *
 *  license in 'license.txt'.  In particular, you may not remove either of *
 *  these copyright notices.						   *
 *									   *
 *  Much time and thought has gone into this software and you are	   *
 *  benefitting.  We hope that you share your changes too.  What goes	   *
 *  around, comes around.						   *
 ***************************************************************************/

/***************************************************************************
*	ROM 2.4 is copyright 1993-1996 Russ Taylor			   *
*	ROM has been brought to you by the ROM consortium		   *
*	    Russ Taylor (rtaylor@efn.org)				   *
*	    Gabrielle Taylor						   *
*	    Brian Moore (zump@rom.org)					   *
*	By using this code, you have agreed to follow the terms of the	   *
*	ROM license, in the file Rom24/doc/rom.license			   *
***************************************************************************/

struct ghostaffect_type
{
	char *name;
	int  true_flag;
	int  ghost_flag;
};


struct plane_types
{
	char *name;
	int  plane;
};

struct damage_type
{
    char *attack1;
    char *attack2;
    int  DAM_TYPE;
};

struct renown_rank_type
{
	sh_int glory;
	sh_int honor;
	sh_int wisdom;
};

struct trait_type
{
	char *name;
	int  trait_flag;
	int  cp_cost;
	bool show_player;
	int  trait_set;
};

struct cset_powers_type
{
	char	*power_name;
	int		power_value;
	int		power_class;
};

struct commands_type
{
	int		set_type; 	//Exam: DISC_THAUM		
	sh_int	set_num;  	//Exam: 1 (For Tham 1)
	sh_int	gift_type; 	//Exam: TRIBE_SHDOWLORDS or BREED_LUPUS (0 = N/A, 1 = Breed, 2 = Auspice, 3 = Tribe)
	char  * name;	  	//Name of skill
	char  * command;    //comand to exec
    int     pool_cost;  //Cost to that class in thier pool..(Old wwf will be 0)
    int     wait_time; //Time to wait for command to be over
    int     command_type;//Type of command
    POWER_FUN * power_fun; //Function to call
};

struct sect_type
{
	int		number;
	char *	pretty_name;
	int     spc_bit;
	char *  color;
    char *  alias;
	 
};

struct iclan_type
{
	int		number;
	char *	pretty_name;
	int     sect;
	char *  color;
	int		creature;	 
};

struct rent_type
{
	int	obj_vnum;
	char * 	obj_name;
	int	exp_cost;
	int	qp_cost;
};

struct gifts_type
{
	char * first_name;
	int    first_mud_name;
	char * second_name;
	int    second_mud_name;
	char * third_name;
	int    third_mud_name;
};

struct haunt_type
{
	char * haunt;
};

struct mage_spell_type
{
	char * spell_name;
	char * on_msg;
	char * off_msg;
};

struct mage_sphere_type
{
	char * sphere_name;
	int    sphere_sphere;
};

struct dumb_shit_type
{
	char * command;
};

struct msp_type
{
	char * msp_string;
	char * msp_server;
	char * msp_dirinfo;
};

struct flag_type
{
	char *name;
	int bit;
	bool settable;
};

struct clan_type
{
	char 	*name;
	char 	*who_name;
	sh_int 	hall;
	bool	independent; /* true for loners */
};

struct position_type
{
	char *name;
	char *short_name;
};

struct sex_type
{
	char *name;
};

struct size_type
{
	char *name;
};

struct	bit_type
{
	const	struct	flag_type *	table;
	char *				help;
};

/* game tables */
extern  const   struct  cset_powers_type cset_powers_list[];
extern	const	struct	position_type	position_table[];
extern	const	struct	sex_type	sex_table[];
extern	const	struct	size_type	size_table[];

extern  const   struct  dumb_shit_type  dumb_shit[];
extern  const   struct  mage_spell_type mage_affect_table[];
extern	const	struct	mage_sphere_type mage_sphere_table[];
extern	const	struct	haunt_type 	haunt_table[];
extern	const	struct	haunt_type 	stance_msg_table[];
extern	const	struct	haunt_type 	remember_table[];
extern	const	struct	haunt_type 	disc_table[];

/* For Random MSP */
extern	const	struct	msp_type	msp_midi_table[];
extern	const	struct	msp_type	msp_scream_table[];
extern	const	struct	msp_type	msp_general_table[];

/* flag tables */
extern	const	struct	flag_type	act_flags[];
extern	const	struct	flag_type	plr_flags[];
extern	const	struct	flag_type	affect_flags[];
extern	const	struct	flag_type	off_flags[];
extern	const	struct	flag_type	imm_flags[];
extern	const	struct	flag_type	form_flags[];
extern	const	struct	flag_type	part_flags[];
extern	const	struct	flag_type	comm_flags[];
extern	const	struct	flag_type	mob_fight_flags[];
extern	const	struct	flag_type	extra_flags[];
extern	const	struct	flag_type	wear_flags[];
extern	const	struct	flag_type	weapon_flags[];
extern	const	struct	flag_type	container_flags[];
extern	const	struct	flag_type	portal_flags[];
extern	const	struct	flag_type	room_flags[];
extern	const	struct	flag_type	exit_flags[];
extern  const	struct  flag_type	mprog_flags[];
extern  const	struct  flag_type	mprog_obj_flags[];
extern  const	struct  flag_type	mprog_room_flags[];
extern	const	struct	flag_type	area_flags[];
extern	const	struct	flag_type	sector_flags[];
extern	const	struct	flag_type	door_resets[];
extern	const	struct	flag_type	wear_loc_strings[];
extern	const	struct	flag_type	wear_loc_flags[];
extern	const	struct	flag_type	res_flags[];
extern	const	struct	flag_type	imm_flags[];
extern	const	struct	flag_type	vuln_flags[];
extern	const	struct	flag_type	type_flags[];
extern	const	struct	flag_type	apply_flags[];
extern	const	struct	flag_type	sex_flags[];
extern	const	struct	flag_type	furniture_flags[];
extern	const	struct	flag_type	weapon_class[];
extern	const	struct	flag_type	apply_types[];
extern	const	struct	flag_type	weapon_type2[];
extern	const	struct	flag_type	apply_types[];
extern	const	struct	flag_type	size_flags[];
extern	const	struct	flag_type	position_flags[];
extern	const	struct	flag_type	ac_type[];
extern	const	struct	flag_type	spc_flags[];
extern	const	struct	bit_type	bitvector_type[];
extern  const	struct  flag_type	mprog_flags[];
extern 	const	struct 	flag_type	attack_table[];
extern 	const	struct 	flag_type	mob_con_flags[];
/*
 * wwf tables definitions 
 */

extern  const   struct  sect_type	sect_table[];
extern  const   struct  iclan_type	iclan_table[];
extern 	const 	struct  rent_type	rent_table[];
extern 	const 	struct  trait_type	trait_table[];

extern  const	struct 	commands_type	hunter_cmds[];
extern  const	struct 	commands_type	mage_cmds[];
extern	const	struct	commands_type	vamp_cmds1[];
extern	const	struct	commands_type	vamp_cmds2[];
extern	const	struct	commands_type	wwf_tot_cmds[];
extern	const	struct	commands_type	wwf_gift_cmds[];
extern  const   struct  renown_rank_type ragabash_table[];
extern  const   struct  renown_rank_type theurge_table[];
extern  const   struct  renown_rank_type philodox_table[];
extern  const   struct  renown_rank_type galliard_table[];
extern  const   struct  renown_rank_type ahroun_table[];
extern  const   struct  damage_type damage_table[];
extern  const   struct  haunt_type  	tribe_table     [];
extern  const   struct  haunt_type  	breed_table     [];
extern  const   struct  haunt_type  	auspice_table     [];


extern  const   struct  plane_types  	plane_table     [];
extern  const   struct  ghostaffect_type ghostaffect_table[];


